{
  inputs = {
    nixpkgs.url =
      "github:NixOS/nixpkgs/ff8b619cfecb98bb94ae49ca7ceca937923a75fa";
    rust-overlay.url = "github:oxalica/rust-overlay";
    flake-utils.url = "github:numtide/flake-utils";
  };

  outputs = { self, nixpkgs, rust-overlay, flake-utils, ... }:
    flake-utils.lib.eachDefaultSystem (system:
      let
        overlays = [ (import rust-overlay) ];
        pkgs = import nixpkgs { inherit system overlays; };
      in with pkgs; {
        devShells.default = mkShell {
          buildInputs = [
            (rust-bin.nightly."2022-09-02".default.override {
              extensions = [ "rust-src" ];
              targets = [ "wasm32-unknown-emscripten" ];
            })
            libclang
            emscripten
          ];
          C_INCLUDE_PATH = "${emscripten}/share/emscripten/cache/sysroot/include";
          LIBCLANG_PATH = "${libclang.lib}/lib";
          EM_CACHE = "/tmp/emscripten-cache";
        };
      });
}
